// vim:fdm=syntax
// by tuberry
/* exported Fields Field */
'use strict';

var Fields = {
    MENUKEY:        'menu-key',
    QUITKEY:        'quit-key',
    AUTOCOPY:       'auto-copy',
    MENUSIZE:       'menu-size',
    MENUSTYLE:      'menu-style',
    NOTIFYSTYLE:    'notify-style',
    ENABLEFORMAT:   'enable-format',
    ENABLENOTIFY:   'enable-notify',
    PREVIEW:        'preview-style',
    COLORSHISTORY:  'colors-history',
    ENABLEPREVIEW:  'enable-preview',
    ENABLESYSTRAY:  'enable-systray',
    FORMAT:         'default-format',
    ENABLESHORTCUT: 'enable-shortcut',
    PERSISTENTMODE: 'persistent-mode',
    COLORSCOLLECT:  'colors-collection',
    SYSTRAYICON:    'systray-dropper-icon',
    PICKSHORTCUT:   'color-picker-shortcut',
};

var Field = class {
    constructor(prop, gset, obj, tie) {
        this.prop = {};
        this.gset = typeof gset === 'string' ? new imports.gi.Gio.Settings({ schema: gset }) : gset;
        this.attach(prop, obj, tie);
    }

    get(k) {
        return this.gset[`get_${this.prop[k][1]}`](this.prop[k][0]);
    }

    set(k, v) {
        this.gset[`set_${this.prop[k][1]}`](this.prop[k][0], v);
    }

    attach(ps, a, n) { // n && ps <- { field: [key, type, output] }
        Object.assign(this.prop, ps);
        let fs = Object.entries(ps);
        let cb = n ? x => { a[n] = [x, this.get(x), this.prop[x][2]]; } : x => { a[x] = this.get(x); };
        fs.forEach(([k]) => cb(k));
        this.gset.connectObject(...fs.flatMap(([k, [x]]) => [`changed::${x}`, () => cb(k)]), a);
        return this;
    }

    detach(a) {
        this.gset.disconnectObject(a);
    }
};
